// Based on https://git.ablecorp.us/AbleOS/holey-bytes/src/branch/trunk/spec.md

// Program execution control
`define UN      'h00
`define UN_ARGS     {ARG_N, ARG_N, ARG_N, ARG_N}
`define TX      'h01
`define TX_ARGS     {ARG_N, ARG_N, ARG_N, ARG_N}
`define NOP     'h02
`define NOP_ARGS    {ARG_N, ARG_N, ARG_N, ARG_N}

// Binary register-register operations
`define ADD8    'h03
`define ADD8_ARGS   {ARG_R, ARG_R, ARG_R, ARG_N}
`define ADD16   'h04
`define ADD16_ARGS  {ARG_R, ARG_R, ARG_R, ARG_N}
`define ADD32   'h05
`define ADD32_ARGS  {ARG_R, ARG_R, ARG_R, ARG_N}
`define ADD64   'h06
`define ADD64_ARGS  {ARG_R, ARG_R, ARG_R, ARG_N}

// Merged divide-remainder
`define DIRU8   'h20

// Unary register operations
`define NEG     'h28
`define NOT     'h29

// Binary register-immediate operations
`define ADDI8   'h2D
`define ADDI8_ARGS  {ARG_R, ARG_R, ARG_B, ARG_N}
`define ADDI16  'h2E
`define ADDI16_ARGS {ARG_R, ARG_R, ARG_H, ARG_N}
`define ADDI32  'h2F
`define ADDI32_ARGS {ARG_R, ARG_R, ARG_W, ARG_N}
`define ADDI64  'h30
`define ADDI64_ARGS {ARG_R, ARG_R, ARG_D, ARG_N}

// Register-immediate bitshifts
`define SLUI8   'h38

// Register copies
`define CP      'h46

// Load immediate
`define LI8     'h48
`define LI8_ARGS    {ARG_R, ARG_B, ARG_N, ARG_N}
`define LI16    'h49
`define LI16_ARGS   {ARG_R, ARG_H, ARG_N, ARG_N}
`define LI32    'h4A
`define LI32_ARGS   {ARG_R, ARG_W, ARG_N, ARG_N}
`define LI64    'h4B
`define LI64_ARGS   {ARG_R, ARG_D, ARG_N, ARG_N}

// Absolute addresing memory access operations
`define LD      'h4D
`define LD_ARGS     {ARG_R, ARG_R, ARG_A, ARG_H}
`define ST      'h4E
`define ST_ARGS     {ARG_R, ARG_R, ARG_A, ARG_H}

// Conditional jump
`define JEQ     'h56

// Environment traps
`define ECA     'h5C
`define ECA_ARGS    {ARG_N, ARG_N, ARG_N, ARG_N}
`define EBP     'h5D
`define EBP_ARGS    {ARG_N, ARG_N, ARG_N, ARG_N}