#!/usr/bin/env python3
import sys

instructions = {
    0x00: "UN",
    0x01: "TX",
    0x02: "NOP",
    0x03: "ADD8",
    0x04: "ADD16",
    0x05: "ADD32",
    0x06: "ADD64",
    0x2D: "ADDI8",
    0x2E: "ADDI16",
    0x2F: "ADDI32",
    0x30: "ADDI64",
    0x48: "LI8",
    0x49: "LI16",
    0x4A: "LI32",
    0x4B: "LI64",
    0x4D: "LD",
    0x4E: "ST",
    0x5D: "EBP"
}

def main():
    fh_in = sys.stdin
    fh_out = sys.stdout

    while True:
        # incoming values have newline
        l = fh_in.readline()
        if not l:
            return 0

        if "x" in l.lower() or "z" in l.lower():
            fh_out.write(l)
        else:
            fh_out.write(f"{instructions.get(int(l, 16))}\n")

        fh_out.flush()

if __name__ == '__main__':
	sys.exit(main())